
#ifndef MULTI_METHOD_FWD_H
#define MULTI_METHOD_FWD_H

#include <functional>
#include <tuple>
#include <utility>
#include <type_traits>

namespace sykes{
    
    struct static_caster{};
    struct dynamic_caster{};

namespace multi_method{

    template<typename IDT, IDT N, typename Tp>
    struct id_and_type{
        typedef IDT id_type;
        static IDT const id = N;
        typedef Tp type;
    };
    
    template<typename IDT, std::size_t Dim>
    struct key
    {
        static_assert(Dim != 0, "struct multi_method::key");
        
        typedef typename
            tupleN<Dim, IDT>::type type;
    };
    
    template<typename IDT>
    struct key<IDT, 1>
    {
        typedef IDT type;
    };
    
    template<typename KeyType, KeyType C>
    struct key_constant{};
}}//---- namespace

#endif

