
#ifndef MULTI_METHOD_MAKE_FUNCTION_MAP_H
#define MULTI_METHOD_MAKE_FUNCTION_MAP_H

#include <map>
#include <functional>
#include <tuple>
#include "utility.h"
#include "vector_c.h"
#include "fwd.h"
#include "detail.h"

namespace sykes{ namespace multi_method{
    
    template<typename Fsig, typename Func, typename Caster, typename IdTp1, typename ... IdTps>
    std::map<
        typename key<
            typename IdTp1::id_type,
            std::tuple_size<typename _arg_type<Fsig>::type>::value
        >::type,
        std::function<Fsig>
    >
    make_function_map()
    {
        static std::size_t const arg_num
            = std::tuple_size<typename _arg_type<Fsig>::type>::value;
        static std::size_t const N = std::tuple_size<std::tuple<IdTp1, IdTps ...>>::value;
        typedef typename key<typename IdTp1::id_type, arg_num>::type key_type;
        typedef std::function<Fsig> function_type;
        typedef std::map<key_type, function_type> map_type;
        
        map_type map_tmp;
        
        detail::_insert_elements<
                Fsig,
                Func,
                map_type,
                Caster,
                typename vector_c_N<arg_num, std::size_t, 0>::type,
                typename vector_c_N<arg_num, std::size_t, 0>::type,
                typename vector_c_N<arg_num, std::size_t, N>::type,
                IdTp1, IdTps ...
            >::execute(map_tmp);
        
        return map_tmp;
    }

}}//---- namespace
#endif

