#ifndef VECTOR_C_OUTPUT_H
#define VECTOR_C_OUTPUT_H

#include <iostream>
#include <sstream>
#include <type_traits>
#include "vector_c.h"

namespace sykes{
    
    template<std::size_t N, typename vec>
    struct _vector_c_output_helper;
    
    template<typename Vui>
	std::ostream& operator<<(
		typename std::enable_if<
			is_vector_c<Vui>::value,
			std::ostream&
		>::type _ost,
		Vui const& _vui)
	{
		std::ostringstream osst;
		osst.flags(_ost.flags ());
		osst.imbue(_ost.getloc ());
		osst.precision(_ost.precision ());
		
		osst << "{";
		_vector_c_output_helper<vector_c_size<Vui>::value, Vui>::process(osst);
		osst << "}";
		
		return _ost << osst.str().c_str();
	}
	
	template<std::size_t N, typename Vui>
    struct _vector_c_output_helper
    {
        static void process(std::ostringstream& _ost)
        {
            _ost << vector_c_at<vector_c_size<Vui>::value - N, Vui>::value;
            _ost << ",";
            _vector_c_output_helper<N - 1, Vui>::process(_ost);
        }
    };
    
	template<typename Vui>
    struct _vector_c_output_helper<1, Vui>
    {
        static void process(std::ostringstream& _ost)
        {
            _ost << vector_c_at<vector_c_size<Vui>::value - 1, Vui>::value;
        }
    };
    
	template<typename Vui>
    struct _vector_c_output_helper<0, Vui>
    {
        static void process(std::ostringstream& _ost)
        {
        }
    };
}//----

#endif

